<script context="module">
  import { Api, ApiError } from "../../../api.js"

  export async function preload(page, { config }) {
    const { bopiId } = page.params
    const api = new Api(config, { fetch: this.fetch })

    let bopi
    try {
      bopi = await api.bopiShow(bopiId)
    } catch (error) {
      if (error instanceof ApiError) {
        return this.error(500, error)
      }
      throw error
    }

    return { bopi }
  }
</script>

<script>
  export let bopi

  import { stores } from "@sapper/app"
  import Badge from "sveltestrap/src/Badge.svelte"
  import * as model from "../../../model.js"
  import BopiInfos from "../../../components/BopiInfos.svelte"
  import ButtonIcon from "../../../components/ButtonIcon.svelte"
  import FilesTable from "../../../components/FilesTable.svelte"
  import TaskInfo from "../../../components/TaskInfo.svelte"

  const { session } = stores()
  const { config } = $session

  // Handy shortcuts
  const isGenerationInProgress = model.isGenerationInProgress(
    bopi.tasks.latest
  )
  const disablePublishButton = bopi.archived || isGenerationInProgress
  const publishButtonTitle = bopi.archived
    ? "Impossible de publier, le BOPI est archivé"
    : isGenerationInProgress
    ? "Impossible de publier, le BOPI est déjà en cours de génération"
    : "Publier le BOPI"

  if (process.browser && isGenerationInProgress) {
    const nbSeconds = 60
    setTimeout(() => {
      window.location.reload()
    }, nbSeconds * 1000)
  }
</script>

<svelte:head>
  <title>bopyweb | Visualisation du BOPI n°{bopi.id}</title>
</svelte:head>

<h1 class="page-title">
  BOPI n°{bopi.id}
  {#if bopi.archived}
    <Badge color="primary">archivé</Badge>
  {/if}
</h1>

<div class="my-5">
  <ButtonIcon icon="bx-arrow-back" href=".">Retour à l'accueil</ButtonIcon>
</div>

{#if !bopi.archived && bopi.tasks.latest}
  <TaskInfo task={bopi.tasks.latest} />
{/if}

<div class="my-5">
  <BopiInfos {bopi} />
</div>

<div class="my-5">
  <FilesTable {bopi} />
</div>

<div class="buttons mt-5">
  {#if bopi.pdf}
    <ButtonIcon
      icon="bxs-file-pdf"
      href={config.apiUrl + bopi.pdf.path}
      title="Télécharger {bopi.pdf.name}">
      Télécharger le PDF
    </ButtonIcon>
  {:else}
    <ButtonIcon icon="bxs-file-pdf" disabled title="Aucun PDF disponible">
      Télécharger le PDF
    </ButtonIcon>
  {/if}

  {#if disablePublishButton}
    <ButtonIcon
      icon="bx-book"
      color="primary"
      disabled
      title={publishButtonTitle}>
      Publier
    </ButtonIcon>
  {:else}
    <ButtonIcon
      icon="bx-book"
      color="primary"
      href={`./bopi/${bopi.id}/publish`}
      title={publishButtonTitle}>
      Publier
    </ButtonIcon>
  {/if}
</div>
